
template<int bullet>
void shootfrom(Pos p);

void explodefrom(Pos p);


typedef void MoveFn(Pos& pos, int t);

struct Entity {
	Pos pos;
	int health;
	bool targeted[MAXPARTS];
	int image;
	Pos extents;
	bool (*doMove)(Entity& ent);
	bool (*canTarget)(int i);
	bool (*onHit)(Entity& ent, int i);
	int movepar;
};


const int MAXENTITIES=500;
int entitycount;
Entity entities[MAXENTITIES];
int toremove[MAXENTITIES];
int removecount;
Pos shootpoints[30];
Pos shootsource;
int shoottimer;
bool realshoot;

Pos extents[SPRITECOUNT];

int colors[SPRITECOUNT];
bool spritemask[SPRITECOUNT][SCREEN_WIDTH][SCREEN_HEIGHT];

Pos targeted[SPRITECOUNT*MAXPARTS];

void spawnentity(int n, int y);

bool noHit(Entity& ent, int i)
{
	return false;
}

bool basicHit(Entity& ent, int i)
{
	ent.health-=shootcount;
	return (ent.health<=0);
}


bool explodeVert(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		shootfrom<7>((Pos){ent.pos.x+1,0});
		return true;
	}
	else
	{
		return false;
	}

}

bool explodeUp(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		shootfrom<9>((Pos){0,ent.pos.y+ent.extents.y/2-120});
		return true;
	}
	else
	{
		return false;
	}

}

bool explodeDown(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		shootfrom<9>((Pos){0,ent.pos.y+ent.extents.y/2});
		return true;
	}
	else
	{
		return false;
	}

}

bool explodeLeft(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		shootfrom<9>((Pos){ent.pos.x+ent.extents.x/2-160,0});
		return true;
	}
	else
	{
		return false;
	}

}

bool explodeRight(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		shootfrom<9>((Pos){ent.pos.x+ent.extents.x/2,0});
		return true;
	}
	else
	{
		return false;
	}

}


bool explodeHor(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		shootfrom<6>((Pos){0,ent.pos.y});
		return true;
	}
	else
	{
		return false;
	}

}

bool explodeBullets(Entity& ent, int i)
{
	ent.health-=shootcount;
	if (ent.health<=0)
	{
		explodefrom((Pos){ent.pos.x+ent.extents.x/2,ent.pos.y+ent.extents.y/2});
		return true;
	}
	else
	{
		return false;
	}

}

bool simpleBeam(int i)
{
	return true;
}

bool noTarget(int i)
{
	return false;
}

template<int n>
bool numTarget(int i)
{
	if (n>numhastargeted+1)
		return false;
	else
	{
		if (n==numhastargeted+1)
			numhastargeted=n;
		return true;
	}
}


struct PlayerEntity: Entity{
	Pos vel;
};

PlayerEntity player;


template<int r>
bool sinMove(Entity& ent)
{
	ent.pos.y+=(int)(cos((float)ent.pos.x/10)*r)-(int)(cos((float)(ent.pos.x-1)/10)*r);
	ent.pos.x--;

	ent.movepar=(ent.movepar+1)%40;

	if (ent.movepar==0)
	{
		shootfrom<1>(
					 (Pos)
					 {
					 ent.pos.x-3,
					 ent.pos.y+ent.extents.y/2
					 }
					 );
	}


	return (ent.pos.x+ent.extents.x<=0);
}

template<int r>
bool zigzag(Entity& ent)
{
	ent.pos.x--;

	ent.movepar=(ent.movepar+1)%r;

	if (ent.movepar>=r/2)
	{
		ent.pos.y++;
	}
	else
	{
		ent.pos.y--;
	}

	if (ent.movepar==0 || ent.movepar==r/2)
	{
		shootfrom<1>(
					 (Pos)
					 {
					 ent.pos.x-3,
					 ent.pos.y+ent.extents.y/2
					 }
					 );
	}


	return (ent.pos.x+ent.extents.x<=0);
}


template<int r>
bool pairFire(Entity& ent)
{
	ent.pos.x--;

	ent.movepar=(ent.movepar+1)%r;



	if (ent.movepar==0)
	{
		shootfrom<0>(
					 (Pos)
					 {
					 ent.pos.x-3,
					 ent.pos.y+1
					 }
					 );
		shootfrom<0>(
					 (Pos)
					 {
					 ent.pos.x-3,
					 ent.pos.y+ent.extents.y-1
					 }
					 );
	}


	return (ent.pos.x+ent.extents.x<=0);
}



bool staticMove(Entity& ent)
{
	return (ent.pos.x+ent.extents.x<=0);

//	pos.x--;

}


bool bossMove1(Entity& ent)
{
	if (ent.movepar<40)
	{
		ent.movepar++;
		ent.pos.x--;
	}
	else
	{
		if (ent.movepar==40)
		{
			ent.pos.y--;
			if (ent.pos.y<5)
				ent.movepar=41;
		}
		else if (ent.movepar=41)
		{
			ent.pos.y++;
			if (ent.pos.y+ent.extents.y>SCREEN_HEIGHT-5)
				ent.movepar=40;

		}

		if (ent.pos.y%36==0)
		{
			shootfrom<1>(
						 (Pos)
						 {
						 ent.pos.x+2,
						 ent.pos.y
						 }
						 );
		}
		else if (ent.pos.y%44==0)
		{
			shootfrom<1>(
						 (Pos)
						 {
						 ent.pos.x+1,
						 ent.pos.y+19
						 }
						 );
		}
		else if (ent.pos.y%52==0)
		{
			shootfrom<1>(
						 (Pos)
						 {
						 ent.pos.x+1,
						 ent.pos.y+8
						 }
						 );
		}
		else if (ent.pos.y%68==0)
		{
			shootfrom<1>(
						 (Pos)
						 {
						 ent.pos.x+2,
						 ent.pos.y+27
						 }
						 );
		}

	}
	return false;
}


bool bossMove2(Entity& ent)
{
	if (ent.movepar<50)
	{
		ent.movepar++;
		ent.pos.x--;
	}
	else
	{

		if (ent.movepar==50)
		{
			ent.pos.y--;
			if (ent.pos.y<5)
				ent.movepar=51;
		}
		else if (ent.movepar=51)
		{
			ent.pos.y++;
			if (ent.pos.y+ent.extents.y>SCREEN_HEIGHT-5)
				ent.movepar=50;

		}

		if (ent.pos.y%20 ==0)
		{

			shootfrom<0>(
						 (Pos)
						 {
						 ent.pos.x-3,
						 ent.pos.y+3
						 }
						 );

			shootfrom<0>(
						 (Pos)
						 {
						 ent.pos.x-3,
						 ent.pos.y+16
						 }
						 );
		}

		if (rand()%15==0)
		{
			spawnentity(9, (rand()%10)*120/10);
		}

	}
	return false;
}



bool bossMove3(Entity& ent)
{
	if (ent.movepar<50)
	{
		ent.movepar++;
		ent.pos.x--;
	}
	else
	{
		if (ent.pos.y+ent.extents.y<player.pos.y)
			ent.pos.y++;
		else if (ent.pos.y>player.pos.y+player.extents.y)
			ent.pos.y--;
		else
		{
			int my=ent.pos.y+ent.extents.y/2;
			int py=player.pos.y+player.extents.y/2;
			if (my<py)
				ent.pos.y++;
			else if (my>py)
				ent.pos.y--;


			ent.movepar++;
			if (ent.movepar%10==0)
			{
				int r=rand()%targetcount[ent.image];
				explodefrom((Pos){ent.pos.x+targets[ent.image][r].x,ent.pos.y+targets[ent.image][r].y});
			}
		}

		if (rand()%30==0)
		{
			int r=rand()%targetcount[ent.image];
			shootfrom<0>((Pos){ent.pos.x+targets[ent.image][r].x,ent.pos.y+targets[ent.image][r].y});

			shootfrom<0>((Pos){ent.pos.x+targets[ent.image][(r+2%targetcount[ent.image])].x,ent.pos.y+targets[ent.image][(r+2%targetcount[ent.image])].y});

			shootfrom<0>((Pos){ent.pos.x+targets[ent.image][(r+4%targetcount[ent.image])].x,ent.pos.y+targets[ent.image][(r+4%targetcount[ent.image])].y});
		}
	}

	return false;
}

bool bossHit3(Entity& ent, int i)
{
	int found=0;
	for (int j=0;j<shootcount;j++)
	{
		if (entities[targeted[i].x].image==ent.image)
			found++;
	}


	if (found==6)
		ent.health-=shootcount;
	else
	{
		//PLAY A SOUND HERE
	}

	return (ent.health<=0);
}


bool bossMove4(Entity& ent)
{
	if (ent.movepar<50)
	{
		ent.movepar++;
		ent.pos.x--;
	}
	else
	{

		if (ent.movepar==50)
		{
			ent.pos.y--;
			if (ent.pos.y<5)
				ent.movepar=51;
		}
		else if (ent.movepar=51)
		{
			ent.pos.y++;
			if (ent.pos.y+ent.extents.y>SCREEN_HEIGHT-5)
				ent.movepar=50;

		}

		if (ent.pos.y%10==0)
		{
			int r=12+rand()%4;
			spawnentity(r, (rand()%10)*120/10);
		}

	}
	return false;
}

template<int life>
bool lifetime(Entity& ent)
{
	ent.movepar++;
	return (ent.movepar>life);
}

template<int v>
bool moveLeft(Entity& ent)
{
	ent.pos.x-=v;
	return (ent.pos.x+ent.extents.x<=0);
}

template<int dir>
bool moveDir(Entity& ent);

template<>//n
bool moveDir<0>(Entity& ent)
{
	ent.pos.y-=2;
	return (ent.pos.y+ent.extents.y <=0);
}

template<>//ne
bool moveDir<1>(Entity& ent)
{

	ent.pos.x++;
	ent.pos.y--;
	return (ent.pos.x>=SCREEN_WIDTH)||(ent.pos.y+ent.extents.y <=0);
}

template<>//e
bool moveDir<2>(Entity& ent)
{
	ent.pos.x+=2;
	return (ent.pos.x>=SCREEN_WIDTH);
}

template<>//se
bool moveDir<3>(Entity& ent)
{
	ent.pos.y++;
	ent.pos.x++;
	return (ent.pos.x>=SCREEN_WIDTH)||(ent.pos.y>=SCREEN_HEIGHT);
}

template<>//s
bool moveDir<4>(Entity& ent)
{
	ent.pos.y+=2;
	return (ent.pos.y>=SCREEN_HEIGHT);
}

template<>//sw
bool moveDir<5>(Entity& ent)
{
	ent.pos.y++;
	ent.pos.x--;
	return (ent.pos.x+ent.extents.x<=0)||(ent.pos.y>=SCREEN_HEIGHT);
}

template<>//w
bool moveDir<6>(Entity& ent)
{
	ent.pos.x-=2;
	return (ent.pos.x+ent.extents.x<=0);
}

template<>//nw
bool moveDir<7>(Entity& ent)
{
	ent.pos.x--;
	ent.pos.y-=2;
	return (ent.pos.x+ent.extents.x<=0)||(ent.pos.y+ent.extents.y <=0);
}


template<int t>
bool flashfor(Entity& ent)
{
	ent.movepar++;
	return (ent.movepar>t);
}

bool bomberMove(Entity& ent)
{
	ent.movepar=(ent.movepar+1)%60;
	if (ent.movepar>40)
		ent.pos.x--;
	if (ent.movepar==4)
	{
		shootfrom<1>(
					 (Pos)
					 {
					 ent.pos.x-1,
					 ent.pos.y+9
					 }
					 );
	}
	return (ent.pos.x+ent.extents.x<=0);
}

template<int n>
bool moveDown(Entity& ent)
{
	ent.movepar=(ent.movepar+1)%30;
	if (ent.movepar==0)
		shootfrom<1>((Pos){ent.pos.x-1,ent.pos.y+3});
	ent.pos.y+=n;
	ent.pos.x--;
	return (ent.pos.y>=SCREEN_HEIGHT);
}
template<int n>
bool moveUp(Entity& ent)
{
	ent.movepar=(ent.movepar+1)%30;
	if (ent.movepar==0)
		shootfrom<1>((Pos){ent.pos.x-1,ent.pos.y+3});
	ent.pos.y-=n;
	ent.pos.x--;
	return (ent.pos.y+ent.extents.y<0);
}

bool spurtLeft(Entity& ent)
{
	ent.movepar=(ent.movepar+1)%80;
	if (ent.movepar>70)
		ent.pos.x-=2;
	if (ent.movepar==4)
	{
		shootfrom<0>(
					 (Pos)
					 {
					 ent.pos.x-1,
					 ent.pos.y+3
					 }
					 );
	}
	return (ent.pos.x+ent.extents.x<=0);
}

template<int slowness>
bool slowMove(Entity& ent)
{
	ent.movepar=(ent.movepar+1)%slowness;
	if (ent.movepar==0)
		ent.pos.x--;
	return (ent.pos.x+ent.extents.x<=0);

}

bool moveLeft(Entity& ent)
{
	ent.pos.x--;
	return (ent.pos.x+ent.extents.x<=0);
}

template<int n,int bullet,int f>
bool moveShoot(Entity& ent)
{
	ent.movepar++;
	if (ent.movepar%f==0)
		shootfrom<bullet>(ent.pos);
	ent.pos.x--;
	ent.pos.y=n;
	return (ent.pos.x+ent.extents.x<=0);
}



template<int a,int bullet,int f>
bool waveShootHigh(Entity& ent)
{
	ent.movepar++;
	if (ent.movepar%f==0)
		shootfrom<bullet>(ent.pos);	ent.pos.x--;
	ent.pos.y=30+(cos((float)ent.pos.x/10))*a;
	return (ent.pos.x+ent.extents.x<=0);
}

template<int a,int bullet,int f>
bool waveShootMed(Entity& ent)
{
	ent.movepar++;
	if (ent.movepar%f==0)
		shootfrom<bullet>(ent.pos);	ent.pos.x--;
	ent.pos.y=50+(cos((float)ent.pos.x/10))*a;
	return (ent.pos.x+ent.extents.x<=0);
}

template<int a,int bullet,int f>
bool waveShootLow(Entity& ent)
{
	ent.movepar++;
	if (ent.movepar%f==0)
		shootfrom<bullet>(ent.pos);	ent.pos.x--;
	ent.pos.y=90+(cos((float)ent.pos.x/10))*a;
	return (ent.pos.x+ent.extents.x<=0);
}


template<int bullet,int f>
bool moveShoot(Entity& ent)
{
	ent.movepar++;
	if (ent.movepar%f==0)
		shootfrom<bullet>(ent.pos);
	ent.pos.x--;
	return (ent.pos.x+ent.extents.x<=0);
}

template<int s>
bool shootLeft(Entity& ent)
{
	ent.pos.x-=s;
	return (ent.pos.x+ent.extents.x<=0);
}


bool Move2(Entity& ent)
{

	if (ent.pos.x>SCREEN_WIDTH/2)
	{
		if (ent.pos.y>SCREEN_HEIGHT/2+2)
			ent.movepar=max(ent.movepar-1,-2);
		else if (ent.pos.y<SCREEN_HEIGHT/2-2)
			ent.movepar=min(ent.movepar+1,2);
	}
	else
	{
		if (ent.pos.y>SCREEN_HEIGHT/2+2)
			ent.movepar=min(ent.movepar+1,2);
		else if (ent.pos.y<SCREEN_HEIGHT/2-2)
			ent.movepar=max(ent.movepar-1,-2);
	}


	ent.pos.x--;

		ent.pos.y+=ent.movepar;
	return (ent.pos.x+ent.extents.x<=0);

	//	pos.x--;

}
//MOVEMENT FUNCTIONS MUST BE OF TYPE
// void f(Pos& pos, int t)

//TARGET FUNCTIONS MUST BE OF TYPE
// bool t(Pos& beamfrom,NPC& npc)

//void Movement
