

#include <allegro.h>
#include <iostream>
#include <vector>
#include <sstream>
#include <math.h>
#include <list>
#include <map>
#include <fstream>
#include <stack>
#include <algorithm>
#include <time.h>
#include <queue>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif

const int FRAMERATE=30;
const int LEVELLIFE=30*20;
using namespace std;


typedef double num;

const int SCREEN_WIDTH=160;
const int SCREEN_HEIGHT=120;

const int RADIUS = 3;
//const int BASERADIUS = 15;

struct Pos {
	float x;
	float y;
};


int magenta;
int red;
int black;
int white;
int green;
int blue;
int yellow;

int target[2];
bool inbase[2];

Pos pos;

const int CIRCLECOUNT=6;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];
bool deadcircle[CIRCLECOUNT];

//used for targetting numerical enemies


BITMAP* buffer;
BITMAP* titlescreen;


#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

const int ts=13;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

bool collides(Pos& a, Pos& b)
{
	float dx = (a.x-b.x);
	float dy = (a.y-b.y);

	return (dx*dx+dy*dy <= RADIUS*RADIUS);
}



bool spacepressed;
int storyprogress;
bool finishedstory;
bool endmode;
int pauseafter;

class IntroLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_ex(buffer, font, "increpare presents", 4, 50, makecol(100,100,100), -1);

		}
	};

int endmenutimer;

class TitleLoop
	{
	private:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			endmode=false;
			endmenutimer=0;
			playmusic(0);
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;

				if (endmenutimer==10)
					stopmusic();

				return;
			}

			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					playsample(1);
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(5);
					}
					else
					{
						quit=true;
						playsample(5);
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,black);

			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			masked_blit(titlescreen,buffer,0,0,0,0,320,120);
			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_centre_ex(buffer,font,"START",80,58,makecol(100,100,100),makecol(255,255,255));
				textout_centre_ex(buffer,font,"Exit",80,80,makecol(255,255,255),-1);
			}
			else
			{
				textout_centre_ex(buffer,font,"Start",80,58,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_centre_ex(buffer,font,"EXIT",80,80,makecol(100,100,100),makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;
int endtimer=0;

void winlevel()
{
	if (endtimer>0)
		return;

	endtimer=120;
}

void loselevel()
{
	stopmusic();
	endtimer=120;
}


float distsq(Pos a, Pos b)
{
	return ((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
}

enum GameMode {GM_INTRO, GM_PLAY, GM_CUTSCENE, GM_OUTRO} gamemode;
int killcount=0;
int leveltimer=0;
int outrotext;//0 no kills 1 some kills 2 all kills

class GameLoop
	{
	public:

		static void initialize()
		{
			
			gamemode=GM_INTRO;
			leveltimer=0;
			killcount=0;
			srand((unsigned)(time(0)));
			
            quit=false;
            leave=false;
			spacepressed=true;
			
			pos=(Pos){60,60};

            for (int i=0;i<CIRCLECOUNT;i++)
            {
				deadcircle[i]=false;
                circles[i].x=60+(40.0f*cos(2.0f*3.1415926535f*(float)i/CIRCLECOUNT));
                circles[i].y=60+(40.0f*sin(2.0f*3.1415926535f*(float)i/CIRCLECOUNT));
                circelvels[i].x=0;
                circelvels[i].y=0;
            }
		}

		static bool quitcondition()
		{
			return quit||leave;
		}

		static void logic()
		{
			
			if (key[KEY_ESC])
			{
				escpressed=true;
				quit=true;
			}
			else
			{
				escpressed=false;
			}
			
			switch (gamemode)
			{
				case GM_INTRO:
						if (key[KEY_SPACE])
						{
							if (!spacepressed)
							{
								spacepressed=true;

								leveltimer++;
								if (leveltimer>6)
								{
									leveltimer=0;
									gamemode=GM_PLAY;
								}
							}
						}
						else
						{
							spacepressed=false;
						}
					break;
				case GM_PLAY:
				{
					leveltimer++;
					if (leveltimer>LEVELLIFE)
					{
						
						outrotext= killcount>0 ? 1 : 0;
						gamemode=GM_CUTSCENE;
					}
					
					const int v=2;
					target[0]=-1;
					target[1]=-1;
					
					
					
					if (key[KEY_UP])
					{
						if (pos.y-RADIUS>0)
							pos.y-=v;
					}
					if (key[KEY_DOWN])
					{
						if (pos.y+RADIUS<SCREEN_HEIGHT)
							pos.y+=v;
					}
					if (key[KEY_LEFT])
					{
						if (pos.x-RADIUS>0)
							pos.x-=v;
					}
					if (key[KEY_RIGHT])
					{
						if (pos.x+RADIUS<SCREEN_HEIGHT)
							pos.x+=v;
					}
					
					
					float curdistmin=3*RADIUS;
					for (int i=0;i<CIRCLECOUNT;i++)
					{
						if (distsq(circles[i],pos)<(4*RADIUS*RADIUS))
						{
							if (distsq(circles[i],pos)<curdistmin)
							{
								target[0]=i;
								if (!deadcircle[i])
								{
									killcount++;
									playsample(2);
									leveltimer/=2;
									if (killcount>=CIRCLECOUNT)
									{
										outrotext=2;
										spacepressed=true;
										gamemode=GM_OUTRO;
										stopmusic();
										leveltimer=0;
									}
									deadcircle[i]=true;
								}
								curdistmin=distsq(circles[i],pos);
							}
						}
						
					}
				}
					break;
				case GM_CUTSCENE:
				{
					int targetcircle=-1;
					
					float curdistmin=100000;
					for (int i=0;i<CIRCLECOUNT;i++)
					{
						if (!deadcircle[i])
						{
							if (distsq(circles[i],pos)<curdistmin)
							{
								curdistmin=distsq(circles[i],pos);
								targetcircle=i;
							}
						}
					}
					if (pos.x<circles[targetcircle].x)
						pos.x++;
					else if (pos.y>circles[targetcircle].y)
						pos.x--;
					
					if (pos.y<circles[targetcircle].y)
						pos.y++;
					else if (pos.y>circles[targetcircle].y)
						pos.y--;

					if (distsq(circles[targetcircle],pos)<4*RADIUS*RADIUS)
					{
						killcount++;
						playsample(2);
						deadcircle[targetcircle]=true;
						if (killcount>=CIRCLECOUNT)
						{
							gamemode=GM_OUTRO;
							leveltimer=0;
							spacepressed=true;
						}
					}

					
				}
					break;
				case GM_OUTRO:
				{
					const int outrotextcount[3]={17,6,16};
					
					if (key[KEY_SPACE])
					{
						if (!spacepressed)
						{
							spacepressed=true;
							
							leveltimer++;
							if (leveltimer>=outrotextcount[outrotext])
							{
								leveltimer=0;
								escpressed=true;
								quit=true;
							}
						}
					}
					else
					{
						spacepressed=false;
					}		
				}
					break;
			}
			
			

		}

		static void draw()
		{


			
			clear_to_color(buffer, black);
			
#define text1(x) textout_ex(buffer, font,x, 4, 30, makecol(255,255,255), makecol(0,0,0))
#define text2(x) textout_ex(buffer, font,x, 4, 50, makecol(255,255,255), makecol(0,0,0))
#define text3(x) textout_ex(buffer, font,x, 4, 70, makecol(255,255,255), makecol(0,0,0))
			
			
#define text1b(x) textout_ex(buffer, font,x, 4, 60, makecol(0,255,255), makecol(0,0,0))
#define text2b(x) textout_ex(buffer, font,x, 4, 80, makecol(0,255,255), makecol(0,0,0))
#define text3b(x) textout_ex(buffer, font,x, 4, 100, makecol(0,255,255), makecol(0,0,0))
			
			switch (gamemode)
			{
				case GM_INTRO:
					switch (leveltimer)
					{
						case 0:
							text1("Listen, my boy,");
							text2("do not give in.");
							break;
						case 1:
							text1("Your desire,");
							text2("your lusts,");
							text3("they are evil.");
							break;
						case 2:
							text1("Do not let");
							text2("your evil urges");
							text3("win out.");
							break;
						case 3:
							text1("Fight every day");
							text2("to make it so.");
							break;
						case 4:
							text1("We all pray you");
							text2("a virtuous life,");
							break;
						case 5:
							text1("but it is your life");
							text2("to live.");
							break;
						case 6:
							text1("Now go, please God,");
							text2("in peace.");
							break;
					}
					break;
				case GM_CUTSCENE:
					clear_to_color(buffer, makecol(50,0,0));
					rectfill(buffer,120,0,159,119,white);
				case GM_PLAY:
					rectfill(buffer,120,120*(LEVELLIFE-leveltimer)/LEVELLIFE,159,119,white);
					for (int i=0;i<CIRCLECOUNT;i++)
					{
						if (deadcircle[i])
							circle(buffer,circles[i].x,circles[i].y,RADIUS,red);
						else
							circlefill(buffer,circles[i].x,circles[i].y,RADIUS,red);
						
					}
					
					
					if (leveltimer>2*LEVELLIFE/3)
						rect(buffer,pos.x-RADIUS+rand()%3-1,pos.y-RADIUS+rand()%3-1,pos.x+RADIUS+rand()%3-1,pos.y+RADIUS+rand()%3-1,green);
					else
						rect(buffer,pos.x-RADIUS-1,pos.y-RADIUS-1,pos.x+RADIUS+1,pos.y+RADIUS,green);
					
					
					break;
				case GM_OUTRO:
				{
					switch(outrotext)
					{
						case 0://no kills
							switch (leveltimer)
							{
								case 0:
									text1("I simply cannot");
									text2("understand.");
									break;
								case 1:
									text1("You were such a");
									text2("model citizen.");
									text3("");
									break;
								case 2:
									text1("Right up until");
									text2("that day.");
									text3("");
									break;
								case 3:
									text1("Why did you");
									text2("do it?");
									break;
								case 4:
									text1b("I don't know,");
									text2b("your honour.");
									break;
								case 5:
									text1b("I don't know");
									text2b("why then.");
									break;
								case 6:
									text1b("I just snapped.");
									text2b("");
									break;
								case 7:
									text1b("Feelings I had");
									text2b("been holding in");
									text3b("for a lifetime.");
									break;
								case 8:
									text1b("Suddenly took");
									text2b("control of me.");
									break;
								case 9:
									text1("And that was that?");
									break;
								case 10:
									text1b("I can't put it");
									text2b("any better way.");
									break;
								case 11:
									text1("I don't believe");
									text2("you.");
									break;
								case 12:
									text1("A rational man does");
									text2("not just abandon");
									text3("his reason.");
									break;
								case 13:
									text1("I hold you fully");
									text2("responsible for");
									text3("your actions.");
									break;
								case 14:
									text1b("If I could undo");
									text2b("things,");
									text3b("I would.");
									break;
								case 15:
									text1("It's too late for");
									text2("that now, Sir.");
									break;
								case 16:
									text1b("I'm so sorry");
									text2b("...");
									break;
							}
							break;
						case 1://some kills
							switch (leveltimer)
						{
							case 0:
								text1("You have");
								text2("a history of");
								text3("violent behaviour.");
								break;
							case 1:
								text1("Society's best");
								text2("efforts to");
								text3("help you failed.");
								break;
							case 2:
								text1("We have no");
								text2("other choice");
								text3("left.");
								break;
							case 3:
								text1("Do you have");
								text2("anything to say?");
								break;
							case 4:
								text1b("No,");
								text2b("your honour,");
								text3b("I don't.");
								break;
							case 5:
								text1("So be it, then.");
								break;
						}
							break;
						case 2://all kills
							switch (leveltimer)
						{
							case 0:
								text1("Yours is a life");
								text2("drenched in ");
								text3("blood.");
								break;
							case 1:
								text1("I have no");
								text2("sympathy for");
								text3("you.");
								break;
							case 2:
								text1("Do you have");
								text2("anything to say");
								text3("for yourself?");
								break;
							case 3:
								text1b("Yes.");
								break;
							case 4:
								text1b("Yes I do.");
								break;
							case 5:
								text1b("I am not");
								text2b("a good man.");
								break;
							case 6:
								text1b("But I can");
								text2b("say one thing");
								text3b("at least:");
								break;
							case 7:
								text1b("All of the");
								text2b("things that I");
								text3b("did,");
								break;
							case 8:
								text1b("I did of");
								text2b("my own free will.");
								break;
							case 9:
								text1b("This is");
								text2b("the one thing");
								text3b("I can be proud of.");
								break;
							case 10:
								text1b("I don't care");
								text2b("of the");
								text3b("consequences,");
								break;
							case 11:
								text1b("because they will");
								text2b("be *my*");
								text3b("consequences.");
								break;
							case 12:
								text1b("You sentence me");
								text2b("because you must.");
								break;
							case 13:
								text1b("But every murder");
								text2b("I commited");
								break;
							case 14:
								text1b("was an assertion");
								text2b("of my free will.");
								break;
							case 15:
								text1b("That is all I");
								text2b("have to say.");
								break;
								
						}
							break;
					}
							
				}
					break;
			}


		

		}

	};

template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        stretch_blit(buffer, screen, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, 640, 480);

	}
}


void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	red=makecol(255,0,0);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);



	titlescreen=load_bmp("bmp/titlescreen.bmp",NULL);



}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:

	loop<TitleLoop>();
	if (quit)
	goto end;

			playmusic(0);
		loop<GameLoop>();
		if (quit)
		{
			quit=false;
			goto titletag;
		}
end:
	return 0;

}
END_OF_MAIN()
